{*******************************************************}
{                                                       }
{       Delphi Visual Component Library                 }
{       Custom Containers Pack (CCPack)                 }
{                                                       }
{       Copyright (c) 1997-99, Sergey Orlik             }
{                                                       }
{     Written by:                                       }
{       Sergey Orlik                                    }
{       product manager                                 }
{       Russia, C.I.S. and Baltic States (former USSR)  }
{       Inprise Moscow office                           }
{       e-mail:  sorlik@inprise.ru                      }
{       WWW: http://www.inprise.ru                      }
{                                                       }
{       Personal Home Page:                             }
{       www.geocities.com/SiliconValley/Way/9006/       }
{                                                       }
{*******************************************************}
{$I CCPDEF.INC}

{$IFDEF VER_CB}
  {$ObjExportAll On}
{$ENDIF}

{$IFDEF FPC}
  {$mode delphi}
{$ENDIF}

unit ccregprc;

interface
uses
  SysUtils, Classes, Boxes,
  {$IFNDEF FPC}
    DesignIntf, {DsgnIntf for delphi6 and less}
    {$IFDEF MSWINDOWS}
      Windows, Forms;
    {$ENDIF}
    {$IFDEF LINUX}
      Types, QForms;
    {$ENDIF}
  {$ENDIF}


procedure RegisterCustomContainerProcImpl(AClass: TComponentClass);

implementation

uses
  ccreg, Designer,
  {$IFNDEF FPC}
    TypInfo, DesignEditors,
    {$IFDEF MSWINDOWS}
      DMForm, DesignWindows,{DMDesigner,} WCtlForm;
    {$ENDIF}
    {$IFDEF LINUX}
      DMForm, DesignWindows,{DMDesigner,} WCtlForm;
    {$ENDIF}
  {$ENDIF}


procedure RegisterCustomContainerProcImpl(AClass: TComponentClass);
begin
  if GetBaseContainer(AClass)=-1 then
    raise EComponentError.Create('Cannot register descendant for unknown container class:'+AClass.ClassName+'.');

  if AClass.InheritsFrom(TForm) and not AClass.ClassNameIs('TForm') then
    RegisterCustomModule(AClass, TCustomModule)
  else
    if AClass.InheritsFrom(TDataModule) and not AClass.ClassNameIs('TDataModule')
    then
      RegisterCustomModule(AClass, TDataModuleCustomModule)//TDataModuleDesignerCustomModule)
    else
      if AClass.InheritsFrom(TBox)
         or AClass.InheritsFrom(TControlGroupBox)
         or AClass.InheritsFrom(TControlScrollBox)
         or (AClass.InheritsFrom(TFrame) and not AClass.ClassNameIs('TFrame'))
      then
        RegisterCustomModule(AClass, TWinControlCustomModule)
end;

procedure InitBaseContainerList;
var
  i : integer;
begin
  for i:=0 to High(BaseContainerClassArray) do
    RegisterCustomContainer(BaseContainerClassArray[i]);
end;

initialization
  RegisterCustomContainerProc:=RegisterCustomContainerProcImpl;
  InitBaseContainerList;
finalization
  RegisterCustomContainerProc:=nil;
end.


